# lycoai-ducky-sdk
API for managing RAG configurations, integrations, prompt templates, and backtesting.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.6
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import lycoai-ducky-sdk
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import lycoai-ducky-sdk
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import lycoai-ducky-sdk
from lycoai-ducky-sdk.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://$
# See configuration.py for a list of all supported configuration parameters.
configuration = lycoai-ducky-sdk.Configuration(
    host = "https://$"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: bearer_auth
configuration.api_key['bearer_auth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['bearer_auth'] = 'Bearer'


# Enter a context with an instance of the API client
with lycoai-ducky-sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = lycoai-ducky-sdk.AuthApi(api_client)
    body = lycoai-ducky-sdk.CreateApiKeyRequest() # CreateApiKeyRequest | 

    try:
        # Create API Key
        api_response = api_instance.create_api_key(body)
        print("The response of AuthApi->create_api_key:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AuthApi->create_api_key: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://$*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AuthApi* | [**create_api_key**](docs/AuthApi.md#create_api_key) | **POST** /v1/api-keys | Create API Key
*AuthApi* | [**delete_api_key**](docs/AuthApi.md#delete_api_key) | **DELETE** /v1/api-keys/{key_id} | Delete API Key
*AuthApi* | [**list_api_keys**](docs/AuthApi.md#list_api_keys) | **GET** /v1/api-keys | Get API Keys
*EvalApi* | [**create_evaluator**](docs/EvalApi.md#create_evaluator) | **POST** /v1/evaluators | Create a new evaluator
*EvalApi* | [**delete_evaluator**](docs/EvalApi.md#delete_evaluator) | **DELETE** /v1/evaluators/{evaluator_id} | Delete an evaluator
*EvalApi* | [**get_evaluation_results**](docs/EvalApi.md#get_evaluation_results) | **GET** /v1/evaluations/{evaluation_id} | Get evaluation results by ID
*EvalApi* | [**list_evaluators**](docs/EvalApi.md#list_evaluators) | **GET** /v1/evaluators | List all evaluators for a project
*EvalApi* | [**run_evaluation**](docs/EvalApi.md#run_evaluation) | **POST** /v1/evaluations | Run an evaluation with dynamic RAG strategies for each variant
*EvalApi* | [**update_evaluator**](docs/EvalApi.md#update_evaluator) | **PUT** /v1/evaluators/{evaluator_id} | Update an evaluator
*EvalApi* | [**vote_on_generated_response**](docs/EvalApi.md#vote_on_generated_response) | **POST** /v1/generate/{generation_id}/vote | Upvote or downvote a generated response
*GenApi* | [**create_prompt_template**](docs/GenApi.md#create_prompt_template) | **POST** /v1/prompts/templates | Create a prompt template
*GenApi* | [**delete_prompt_template**](docs/GenApi.md#delete_prompt_template) | **DELETE** /v1/prompts/templates/{template_id} | Delete a prompt template
*GenApi* | [**generate_response**](docs/GenApi.md#generate_response) | **POST** /v1/generate | Generate a response with dynamic configuration
*GenApi* | [**get_prompt_template**](docs/GenApi.md#get_prompt_template) | **GET** /v1/prompts/templates/{template_id} | Get a prompt template
*GenApi* | [**list_prompt_templates**](docs/GenApi.md#list_prompt_templates) | **GET** /v1/prompts/templates | List prompt templates for a project
*GenApi* | [**update_prompt_template**](docs/GenApi.md#update_prompt_template) | **PUT** /v1/prompts/templates/{template_id} | Update an existing prompt template
*HubApi* | [**create_index**](docs/HubApi.md#create_index) | **POST** /v1/indexes | Create an index
*HubApi* | [**create_project**](docs/HubApi.md#create_project) | **POST** /v1/projects | Create a project
*HubApi* | [**delete_document**](docs/HubApi.md#delete_document) | **DELETE** /v1/documents/{document_id} | Delete a document
*HubApi* | [**delete_index**](docs/HubApi.md#delete_index) | **DELETE** /v1/indexes/{index_name} | Delete an index
*HubApi* | [**delete_project**](docs/HubApi.md#delete_project) | **DELETE** /v1/projects/{project_id} | Delete a project
*HubApi* | [**get_document**](docs/HubApi.md#get_document) | **GET** /v1/documents/{document_id} | Get a document by ID with pagination
*HubApi* | [**get_organizations**](docs/HubApi.md#get_organizations) | **GET** /v1/organizations | Get Organizations
*HubApi* | [**get_project**](docs/HubApi.md#get_project) | **GET** /v1/projects/{project_id} | Get a project by ID
*HubApi* | [**index_document_file**](docs/HubApi.md#index_document_file) | **POST** /v1/documents/index-file | Index a document from a file
*HubApi* | [**index_document_text**](docs/HubApi.md#index_document_text) | **POST** /v1/documents/index-text | Index a document from text content
*HubApi* | [**list_indexes**](docs/HubApi.md#list_indexes) | **GET** /v1/indexes | List indexes within a project
*HubApi* | [**list_projects**](docs/HubApi.md#list_projects) | **GET** /v1/projects | List projects
*HubApi* | [**retrieve_documents**](docs/HubApi.md#retrieve_documents) | **POST** /v1/documents/retrieve | Retrieve documents with dynamic configuration and variant name
*HubApi* | [**sign_in**](docs/HubApi.md#sign_in) | **POST** /v1/sign-in | User Sign In
*IngestApi* | [**add_custom_integration**](docs/IngestApi.md#add_custom_integration) | **POST** /v1/integrations/custom | Add a custom integration with metadata field mappings
*IngestApi* | [**add_integration**](docs/IngestApi.md#add_integration) | **POST** /v1/integrations | Add a new integration
*IngestApi* | [**delete_integration**](docs/IngestApi.md#delete_integration) | **DELETE** /v1/integrations/{integration_id} | Delete an integration
*IngestApi* | [**list_integrations**](docs/IngestApi.md#list_integrations) | **GET** /v1/integrations | List all integrations
*IngestApi* | [**update_integration**](docs/IngestApi.md#update_integration) | **PUT** /v1/integrations/{integration_id} | Update an integration
*WebappOnlyApi* | [**create_api_key_0**](docs/WebappOnlyApi.md#create_api_key_0) | **POST** /v1/api-keys | Create API Key
*WebappOnlyApi* | [**delete_api_key_0**](docs/WebappOnlyApi.md#delete_api_key_0) | **DELETE** /v1/api-keys/{key_id} | Delete API Key
*WebappOnlyApi* | [**get_organizations_0**](docs/WebappOnlyApi.md#get_organizations_0) | **GET** /v1/organizations | Get Organizations
*WebappOnlyApi* | [**list_api_keys_0**](docs/WebappOnlyApi.md#list_api_keys_0) | **GET** /v1/api-keys | Get API Keys
*WebappOnlyApi* | [**sign_in_0**](docs/WebappOnlyApi.md#sign_in_0) | **POST** /v1/sign-in | User Sign In


## Documentation For Models

 - [AddCustomIntegrationRequest](docs/AddCustomIntegrationRequest.md)
 - [AddCustomIntegrationRequestAuthDetails](docs/AddCustomIntegrationRequestAuthDetails.md)
 - [AddCustomIntegrationRequestMetadataDynamicFieldMappingsInner](docs/AddCustomIntegrationRequestMetadataDynamicFieldMappingsInner.md)
 - [AddIntegrationRequest](docs/AddIntegrationRequest.md)
 - [AddIntegrationRequestAuthDetails](docs/AddIntegrationRequestAuthDetails.md)
 - [ApiKey](docs/ApiKey.md)
 - [CreateApiKeyRequest](docs/CreateApiKeyRequest.md)
 - [CreateApiKeyResponse](docs/CreateApiKeyResponse.md)
 - [CreateEvaluatorRequest](docs/CreateEvaluatorRequest.md)
 - [CreateIndexRequest](docs/CreateIndexRequest.md)
 - [CreateIndexResponse](docs/CreateIndexResponse.md)
 - [CreateProjectRequest](docs/CreateProjectRequest.md)
 - [CreateProjectResponse](docs/CreateProjectResponse.md)
 - [CreatePromptTemplate](docs/CreatePromptTemplate.md)
 - [CreatePromptTemplateVariantsInner](docs/CreatePromptTemplateVariantsInner.md)
 - [DeletePromptTemplateResponse](docs/DeletePromptTemplateResponse.md)
 - [Document](docs/Document.md)
 - [DocumentIndexedResponse](docs/DocumentIndexedResponse.md)
 - [DocumentRetrievedResponse](docs/DocumentRetrievedResponse.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [EvaluationInitiatedResponse](docs/EvaluationInitiatedResponse.md)
 - [EvaluationResultsResponse](docs/EvaluationResultsResponse.md)
 - [EvaluationResultsResponseEvaluationResultsInner](docs/EvaluationResultsResponseEvaluationResultsInner.md)
 - [EvaluatorCreatedResponse](docs/EvaluatorCreatedResponse.md)
 - [EvaluatorUpdatedResponse](docs/EvaluatorUpdatedResponse.md)
 - [EvaluatorsListResponse](docs/EvaluatorsListResponse.md)
 - [EvaluatorsListResponseEvaluatorsInner](docs/EvaluatorsListResponseEvaluatorsInner.md)
 - [FilterCondition](docs/FilterCondition.md)
 - [GenerateResponse](docs/GenerateResponse.md)
 - [GenerateResponseRequest](docs/GenerateResponseRequest.md)
 - [GenerateResponseRequestQueryTranslationStrategy](docs/GenerateResponseRequestQueryTranslationStrategy.md)
 - [GenerateResponseRequestRetrievalStrategy](docs/GenerateResponseRequestRetrievalStrategy.md)
 - [GenerateResponseRequestRetrievalStrategyContextualCompression](docs/GenerateResponseRequestRetrievalStrategyContextualCompression.md)
 - [GenerateResponseRequestSelfCorrectionStrategy](docs/GenerateResponseRequestSelfCorrectionStrategy.md)
 - [GetOrganizationsResponse](docs/GetOrganizationsResponse.md)
 - [GetProjectResponse](docs/GetProjectResponse.md)
 - [Index](docs/Index.md)
 - [IndexTextRequest](docs/IndexTextRequest.md)
 - [IntegrationAddedResponse](docs/IntegrationAddedResponse.md)
 - [IntegrationUpdatedResponse](docs/IntegrationUpdatedResponse.md)
 - [IntegrationsListResponse](docs/IntegrationsListResponse.md)
 - [IntegrationsListResponseIntegrationsInner](docs/IntegrationsListResponseIntegrationsInner.md)
 - [ListApiKeysResponse](docs/ListApiKeysResponse.md)
 - [ListIndexesResponse](docs/ListIndexesResponse.md)
 - [ListProjectsResponse](docs/ListProjectsResponse.md)
 - [LogicalOperator](docs/LogicalOperator.md)
 - [Organization](docs/Organization.md)
 - [Project](docs/Project.md)
 - [PromptTemplateCreatedResponse](docs/PromptTemplateCreatedResponse.md)
 - [PromptTemplateResponse](docs/PromptTemplateResponse.md)
 - [PromptTemplateResponseVariantsInner](docs/PromptTemplateResponseVariantsInner.md)
 - [PromptTemplatesListResponse](docs/PromptTemplatesListResponse.md)
 - [PromptTemplatesListResponseTemplatesInner](docs/PromptTemplatesListResponseTemplatesInner.md)
 - [PromptTemplatesListResponseTemplatesInnerVariantsInner](docs/PromptTemplatesListResponseTemplatesInnerVariantsInner.md)
 - [QueryTranslationStrategy](docs/QueryTranslationStrategy.md)
 - [RetrievalStrategy](docs/RetrievalStrategy.md)
 - [RetrievalStrategyContextualCompression](docs/RetrievalStrategyContextualCompression.md)
 - [RetrievalStrategyCorrectiveRetrieval](docs/RetrievalStrategyCorrectiveRetrieval.md)
 - [RetrieveDocumentsRequest](docs/RetrieveDocumentsRequest.md)
 - [RetrieveDocumentsRequestQueryStructuring](docs/RetrieveDocumentsRequestQueryStructuring.md)
 - [RetrieveDocumentsResponse](docs/RetrieveDocumentsResponse.md)
 - [RunEvaluationRequest](docs/RunEvaluationRequest.md)
 - [RunEvaluationRequestTestCasesInner](docs/RunEvaluationRequestTestCasesInner.md)
 - [RunEvaluationRequestVariantsInner](docs/RunEvaluationRequestVariantsInner.md)
 - [RunEvaluationRequestVariantsInnerQueryTranslationStrategy](docs/RunEvaluationRequestVariantsInnerQueryTranslationStrategy.md)
 - [RunEvaluationRequestVariantsInnerRetrievalStrategy](docs/RunEvaluationRequestVariantsInnerRetrievalStrategy.md)
 - [RunEvaluationRequestVariantsInnerRetrievalStrategyCorrectiveRetrieval](docs/RunEvaluationRequestVariantsInnerRetrievalStrategyCorrectiveRetrieval.md)
 - [RunEvaluationRequestVariantsInnerSelfCorrectionStrategy](docs/RunEvaluationRequestVariantsInnerSelfCorrectionStrategy.md)
 - [SignInResponse](docs/SignInResponse.md)
 - [UpdateEvaluatorRequest](docs/UpdateEvaluatorRequest.md)
 - [UpdateIntegrationRequest](docs/UpdateIntegrationRequest.md)
 - [UpdateIntegrationRequestAuthDetails](docs/UpdateIntegrationRequestAuthDetails.md)
 - [UpdateIntegrationRequestMetadataFields](docs/UpdateIntegrationRequestMetadataFields.md)
 - [UpdateIntegrationRequestMetadataFieldsDynamicFieldsValue](docs/UpdateIntegrationRequestMetadataFieldsDynamicFieldsValue.md)
 - [UpdatePromptTemplate](docs/UpdatePromptTemplate.md)
 - [UpdatePromptTemplateResponse](docs/UpdatePromptTemplateResponse.md)
 - [UpdatePromptTemplateVariantsInner](docs/UpdatePromptTemplateVariantsInner.md)
 - [User](docs/User.md)
 - [VoteRequest](docs/VoteRequest.md)
 - [VoteResponse](docs/VoteResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="api_key"></a>
### api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header

<a id="bearer_auth"></a>
### bearer_auth

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author

support@ducky.ai


