# coding: utf-8

"""
    RAG as a Service API

    API for managing RAG configurations, integrations, prompt templates, and backtesting.

    The version of the OpenAPI document: 1.0.0
    Contact: support@ducky.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from lycoai-ducky-sdk.models.add_custom_integration_request_auth_details import AddCustomIntegrationRequestAuthDetails
from lycoai-ducky-sdk.models.add_custom_integration_request_metadata_dynamic_field_mappings_inner import AddCustomIntegrationRequestMetadataDynamicFieldMappingsInner
from typing import Optional, Set
from typing_extensions import Self

class AddCustomIntegrationRequest(BaseModel):
    """
    AddCustomIntegrationRequest
    """ # noqa: E501
    index_id: Optional[StrictStr] = Field(default=None, description="The ID of the index to add the items to")
    integration_name: Optional[StrictStr] = Field(default=None, description="The name of the custom integration")
    start_date: Optional[datetime] = Field(default=None, description="Start date for data ingestion")
    endpoint: Optional[StrictStr] = Field(default=None, description="The custom API endpoint for fetching data")
    auth_details: Optional[AddCustomIntegrationRequestAuthDetails] = None
    metadata: Optional[Dict[str, StrictStr]] = Field(default=None, description="Metadata fields associated with docs ingested from the integration")
    metadata_dynamic_field_mappings: Optional[List[AddCustomIntegrationRequestMetadataDynamicFieldMappingsInner]] = None
    __properties: ClassVar[List[str]] = ["index_id", "integration_name", "start_date", "endpoint", "auth_details", "metadata", "metadata_dynamic_field_mappings"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddCustomIntegrationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of auth_details
        if self.auth_details:
            _dict['auth_details'] = self.auth_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in metadata_dynamic_field_mappings (list)
        _items = []
        if self.metadata_dynamic_field_mappings:
            for _item_metadata_dynamic_field_mappings in self.metadata_dynamic_field_mappings:
                if _item_metadata_dynamic_field_mappings:
                    _items.append(_item_metadata_dynamic_field_mappings.to_dict())
            _dict['metadata_dynamic_field_mappings'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddCustomIntegrationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "index_id": obj.get("index_id"),
            "integration_name": obj.get("integration_name"),
            "start_date": obj.get("start_date"),
            "endpoint": obj.get("endpoint"),
            "auth_details": AddCustomIntegrationRequestAuthDetails.from_dict(obj["auth_details"]) if obj.get("auth_details") is not None else None,
            "metadata": obj.get("metadata"),
            "metadata_dynamic_field_mappings": [AddCustomIntegrationRequestMetadataDynamicFieldMappingsInner.from_dict(_item) for _item in obj["metadata_dynamic_field_mappings"]] if obj.get("metadata_dynamic_field_mappings") is not None else None
        })
        return _obj


