# coding: utf-8

"""
    RAG as a Service API

    API for managing RAG configurations, integrations, prompt templates, and backtesting.

    The version of the OpenAPI document: 1.0.0
    Contact: support@ducky.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from lycoai-ducky-sdk.models.document import Document
from typing import Optional, Set
from typing_extensions import Self

class GenerateResponse(BaseModel):
    """
    GenerateResponse
    """ # noqa: E501
    generation_id: Optional[StrictStr] = Field(default=None, description="The unique identifier for the generation")
    generated_text: Optional[StrictStr] = Field(default=None, description="The generated response")
    documents_used: Optional[List[Document]] = None
    config_used: Optional[Dict[str, Any]] = Field(default=None, description="The retrieval, self-correction, and query translation config used for this generation")
    __properties: ClassVar[List[str]] = ["generation_id", "generated_text", "documents_used", "config_used"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GenerateResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in documents_used (list)
        _items = []
        if self.documents_used:
            for _item_documents_used in self.documents_used:
                if _item_documents_used:
                    _items.append(_item_documents_used.to_dict())
            _dict['documents_used'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GenerateResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "generation_id": obj.get("generation_id"),
            "generated_text": obj.get("generated_text"),
            "documents_used": [Document.from_dict(_item) for _item in obj["documents_used"]] if obj.get("documents_used") is not None else None,
            "config_used": obj.get("config_used")
        })
        return _obj


