# coding: utf-8

"""
    RAG as a Service API

    API for managing RAG configurations, integrations, prompt templates, and backtesting.

    The version of the OpenAPI document: 1.0.0
    Contact: support@ducky.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from lycoai-ducky-sdk.models.prompt_templates_list_response_templates_inner_variants_inner import PromptTemplatesListResponseTemplatesInnerVariantsInner
from typing import Optional, Set
from typing_extensions import Self

class PromptTemplatesListResponseTemplatesInner(BaseModel):
    """
    PromptTemplatesListResponseTemplatesInner
    """ # noqa: E501
    template_id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the prompt template")
    template_name: Optional[StrictStr] = Field(default=None, description="The name of the prompt template")
    variants: Optional[List[PromptTemplatesListResponseTemplatesInnerVariantsInner]] = None
    production_variant: Optional[StrictStr] = Field(default=None, description="The name of the variant to use in production")
    __properties: ClassVar[List[str]] = ["template_id", "template_name", "variants", "production_variant"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PromptTemplatesListResponseTemplatesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in variants (list)
        _items = []
        if self.variants:
            for _item_variants in self.variants:
                if _item_variants:
                    _items.append(_item_variants.to_dict())
            _dict['variants'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PromptTemplatesListResponseTemplatesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "template_id": obj.get("template_id"),
            "template_name": obj.get("template_name"),
            "variants": [PromptTemplatesListResponseTemplatesInnerVariantsInner.from_dict(_item) for _item in obj["variants"]] if obj.get("variants") is not None else None,
            "production_variant": obj.get("production_variant")
        })
        return _obj


